
_LCDByte:

;lcd.c,26 :: 		void LCDByte(uint8_t c,uint8_t isdata)
;lcd.c,38 :: 		hn=c>>4;
	MOVF        FARG_LCDByte_c+0, 0 
	MOVWF       LCDByte_hn_L0+0 
	RRCF        LCDByte_hn_L0+0, 1 
	BCF         LCDByte_hn_L0+0, 7 
	RRCF        LCDByte_hn_L0+0, 1 
	BCF         LCDByte_hn_L0+0, 7 
	RRCF        LCDByte_hn_L0+0, 1 
	BCF         LCDByte_hn_L0+0, 7 
	RRCF        LCDByte_hn_L0+0, 1 
	BCF         LCDByte_hn_L0+0, 7 
;lcd.c,39 :: 		ln=(c & 0x0F);
	MOVLW       15
	ANDWF       FARG_LCDByte_c+0, 0 
	MOVWF       LCDByte_ln_L0+0 
;lcd.c,41 :: 		if(isdata==0)
	MOVF        FARG_LCDByte_isdata+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_LCDByte0
;lcd.c,42 :: 		CLEAR_RS();
	BCF         LATB+0, 5 
	GOTO        L_LCDByte1
L_LCDByte0:
;lcd.c,44 :: 		SET_RS();
	BSF         LATB+0, 5 
L_LCDByte1:
;lcd.c,46 :: 		Delay_us(50);                //tAS
	MOVLW       33
	MOVWF       R13, 0
L_LCDByte2:
	DECFSZ      R13, 1, 1
	BRA         L_LCDByte2
;lcd.c,48 :: 		SET_E();
	BSF         LATB+0, 4 
;lcd.c,52 :: 		temp=(LCD_DATA_LAT & 0XF0)|(hn);
	MOVLW       240
	ANDWF       LATB+0, 0 
	MOVWF       R0 
	MOVF        LCDByte_hn_L0+0, 0 
	IORWF       R0, 0 
	MOVWF       LATB+0 
;lcd.c,53 :: 		LCD_DATA_LAT=temp;
;lcd.c,55 :: 		Delay_us(1);                        //tEH
	NOP
	NOP
;lcd.c,59 :: 		CLEAR_E();
	BCF         LATB+0, 4 
;lcd.c,61 :: 		Delay_us(1);
	NOP
	NOP
;lcd.c,64 :: 		SET_E();
	BSF         LATB+0, 4 
;lcd.c,66 :: 		temp=(LCD_DATA_LAT & 0XF0)|(ln);
	MOVLW       240
	ANDWF       LATB+0, 0 
	MOVWF       R0 
	MOVF        LCDByte_ln_L0+0, 0 
	IORWF       R0, 0 
	MOVWF       LATB+0 
;lcd.c,68 :: 		LCD_DATA_LAT=temp;
;lcd.c,70 :: 		Delay_us(1);                        //tEH
	NOP
	NOP
;lcd.c,74 :: 		CLEAR_E();
	BCF         LATB+0, 4 
;lcd.c,76 :: 		Delay_us(1);                        //tEL
	NOP
	NOP
;lcd.c,78 :: 		LCDBusyLoop();
	CALL        _LCDBusyLoop+0, 0
;lcd.c,79 :: 		}
L_end_LCDByte:
	RETURN      0
; end of _LCDByte

_LCDBusyLoop:

;lcd.c,81 :: 		void LCDBusyLoop()
;lcd.c,85 :: 		uint8_t busy,status=0x00,temp;
	CLRF        LCDBusyLoop_status_L0+0 
;lcd.c,88 :: 		LCD_DATA_TRIS|=0x0F;
	MOVLW       15
	IORWF       TRISB+0, 1 
;lcd.c,91 :: 		SET_RW();                //Read mode
	BSF         LATB+0, 6 
;lcd.c,92 :: 		CLEAR_RS();                //Read status
	BCF         LATB+0, 5 
;lcd.c,96 :: 		Delay_us(50);                //tAS
	MOVLW       33
	MOVWF       R13, 0
L_LCDBusyLoop3:
	DECFSZ      R13, 1, 1
	BRA         L_LCDBusyLoop3
;lcd.c,99 :: 		do
L_LCDBusyLoop4:
;lcd.c,102 :: 		SET_E();
	BSF         LATB+0, 4 
;lcd.c,105 :: 		Delay_us(50);
	MOVLW       33
	MOVWF       R13, 0
L_LCDBusyLoop7:
	DECFSZ      R13, 1, 1
	BRA         L_LCDBusyLoop7
;lcd.c,107 :: 		status=LCD_DATA_PORT;
	MOVF        PORTB+0, 0 
	MOVWF       LCDBusyLoop_status_L0+0 
;lcd.c,108 :: 		status=status<<4;
	RLCF        LCDBusyLoop_status_L0+0, 1 
	BCF         LCDBusyLoop_status_L0+0, 0 
	RLCF        LCDBusyLoop_status_L0+0, 1 
	BCF         LCDBusyLoop_status_L0+0, 0 
	RLCF        LCDBusyLoop_status_L0+0, 1 
	BCF         LCDBusyLoop_status_L0+0, 0 
	RLCF        LCDBusyLoop_status_L0+0, 1 
	BCF         LCDBusyLoop_status_L0+0, 0 
;lcd.c,110 :: 		Delay_us(50);
	MOVLW       33
	MOVWF       R13, 0
L_LCDBusyLoop8:
	DECFSZ      R13, 1, 1
	BRA         L_LCDBusyLoop8
;lcd.c,113 :: 		CLEAR_E();
	BCF         LATB+0, 4 
;lcd.c,114 :: 		Delay_us(1);        //tEL
	NOP
	NOP
;lcd.c,116 :: 		SET_E();
	BSF         LATB+0, 4 
;lcd.c,117 :: 		Delay_us(50);
	MOVLW       33
	MOVWF       R13, 0
L_LCDBusyLoop9:
	DECFSZ      R13, 1, 1
	BRA         L_LCDBusyLoop9
;lcd.c,119 :: 		temp=LCD_DATA_PORT;
	MOVF        PORTB+0, 0 
	MOVWF       R2 
;lcd.c,120 :: 		temp&=0x0F;
	MOVLW       15
	ANDWF       R2, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	MOVWF       R2 
;lcd.c,122 :: 		status=status|temp;
	MOVF        LCDBusyLoop_status_L0+0, 0 
	IORWF       R0, 1 
	MOVF        R0, 0 
	MOVWF       LCDBusyLoop_status_L0+0 
;lcd.c,124 :: 		busy=status & 0b10000000;
	MOVLW       128
	ANDWF       R0, 0 
	MOVWF       R1 
;lcd.c,126 :: 		Delay_us(50);
	MOVLW       33
	MOVWF       R13, 0
L_LCDBusyLoop10:
	DECFSZ      R13, 1, 1
	BRA         L_LCDBusyLoop10
;lcd.c,127 :: 		CLEAR_E();
	BCF         LATB+0, 4 
;lcd.c,128 :: 		Delay_us(1);        //tEL
	NOP
	NOP
;lcd.c,129 :: 		}while(busy);
	MOVF        R1, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_LCDBusyLoop4
;lcd.c,131 :: 		CLEAR_RW();                //write mode
	BCF         LATB+0, 6 
;lcd.c,133 :: 		LCD_DATA_TRIS&=0xF0;
	MOVLW       240
	ANDWF       TRISB+0, 1 
;lcd.c,135 :: 		}
L_end_LCDBusyLoop:
	RETURN      0
; end of _LCDBusyLoop

_LCDInit:

;lcd.c,137 :: 		void LCDInit(uint8_t style)
;lcd.c,152 :: 		Delay_ms(60);
	MOVLW       156
	MOVWF       R12, 0
	MOVLW       215
	MOVWF       R13, 0
L_LCDInit11:
	DECFSZ      R13, 1, 1
	BRA         L_LCDInit11
	DECFSZ      R12, 1, 1
	BRA         L_LCDInit11
;lcd.c,155 :: 		LCD_DATA_TRIS&=(0xF0);
	MOVLW       240
	ANDWF       TRISB+0, 1 
;lcd.c,156 :: 		LCD_E_TRIS&=(~(1<<LCD_E_POS));
	BCF         TRISB+0, 4 
;lcd.c,157 :: 		LCD_RS_TRIS&=(~(1<<LCD_RS_POS));
	BCF         TRISB+0, 5 
;lcd.c,158 :: 		LCD_RW_TRIS&=(~(1<<LCD_RW_POS));
	BCF         TRISB+0, 6 
;lcd.c,160 :: 		LCD_DATA_LAT&=0XF0;
	MOVLW       240
	ANDWF       LATB+0, 1 
;lcd.c,161 :: 		CLEAR_E();
	BCF         LATB+0, 4 
;lcd.c,162 :: 		CLEAR_RW();
	BCF         LATB+0, 6 
;lcd.c,163 :: 		CLEAR_RS();
	BCF         LATB+0, 5 
;lcd.c,167 :: 		Delay_us(100);
	MOVLW       66
	MOVWF       R13, 0
L_LCDInit12:
	DECFSZ      R13, 1, 1
	BRA         L_LCDInit12
	NOP
;lcd.c,169 :: 		SET_E();
	BSF         LATB+0, 4 
;lcd.c,170 :: 		LCD_DATA_LAT|=(0b00000010); //[B] To transfer 0b00100000 i was using LCD_DATA_PORT|=0b00100000
	BSF         LATB+0, 1 
;lcd.c,171 :: 		Delay_us(10);
	MOVLW       6
	MOVWF       R13, 0
L_LCDInit13:
	DECFSZ      R13, 1, 1
	BRA         L_LCDInit13
	NOP
;lcd.c,172 :: 		CLEAR_E();
	BCF         LATB+0, 4 
;lcd.c,173 :: 		Delay_us(10);
	MOVLW       6
	MOVWF       R13, 0
L_LCDInit14:
	DECFSZ      R13, 1, 1
	BRA         L_LCDInit14
	NOP
;lcd.c,176 :: 		LCDBusyLoop();                                    //[B] Forgot this delay
	CALL        _LCDBusyLoop+0, 0
;lcd.c,180 :: 		LCDCmd(0b00001100|style);        //Display On
	MOVLW       12
	IORWF       FARG_LCDInit_style+0, 0 
	MOVWF       FARG_LCDByte_c+0 
	CLRF        FARG_LCDByte_isdata+0 
	CALL        _LCDByte+0, 0
;lcd.c,181 :: 		LCDCmd(0b00101000);                        //function set 4-bit,2 line 5x7 dot format
	MOVLW       40
	MOVWF       FARG_LCDByte_c+0 
	CLRF        FARG_LCDByte_isdata+0 
	CALL        _LCDByte+0, 0
;lcd.c,182 :: 		}
L_end_LCDInit:
	RETURN      0
; end of _LCDInit

_LCDWriteString:

;lcd.c,183 :: 		void LCDWriteString(const char *msg)
;lcd.c,195 :: 		while(*msg!='\0')
L_LCDWriteString15:
	MOVF        FARG_LCDWriteString_msg+0, 0 
	MOVWF       TBLPTRL 
	MOVF        FARG_LCDWriteString_msg+1, 0 
	MOVWF       TBLPTRH 
	MOVF        FARG_LCDWriteString_msg+2, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R1
	MOVF        R1, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_LCDWriteString16
;lcd.c,197 :: 		LCDData(*msg);
	MOVF        FARG_LCDWriteString_msg+0, 0 
	MOVWF       TBLPTRL 
	MOVF        FARG_LCDWriteString_msg+1, 0 
	MOVWF       TBLPTRH 
	MOVF        FARG_LCDWriteString_msg+2, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_LCDByte_c+0
	MOVLW       1
	MOVWF       FARG_LCDByte_isdata+0 
	CALL        _LCDByte+0, 0
;lcd.c,198 :: 		msg++;
	MOVLW       1
	ADDWF       FARG_LCDWriteString_msg+0, 1 
	MOVLW       0
	ADDWFC      FARG_LCDWriteString_msg+1, 1 
	ADDWFC      FARG_LCDWriteString_msg+2, 1 
;lcd.c,199 :: 		}
	GOTO        L_LCDWriteString15
L_LCDWriteString16:
;lcd.c,200 :: 		}
L_end_LCDWriteString:
	RETURN      0
; end of _LCDWriteString

_LCDWriteInt:

;lcd.c,202 :: 		void LCDWriteInt(int val,unsigned int field_length)
;lcd.c,215 :: 		char str[5]={0,0,0,0,0};
	CLRF        LCDWriteInt_str_L0+0 
	CLRF        LCDWriteInt_str_L0+1 
	CLRF        LCDWriteInt_str_L0+2 
	CLRF        LCDWriteInt_str_L0+3 
	CLRF        LCDWriteInt_str_L0+4 
	MOVLW       4
	MOVWF       LCDWriteInt_i_L0+0 
	MOVLW       0
	MOVWF       LCDWriteInt_i_L0+1 
	CLRF        LCDWriteInt_j_L0+0 
	CLRF        LCDWriteInt_j_L0+1 
;lcd.c,217 :: 		while(val)
L_LCDWriteInt17:
	MOVF        FARG_LCDWriteInt_val+0, 0 
	IORWF       FARG_LCDWriteInt_val+1, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L_LCDWriteInt18
;lcd.c,219 :: 		str[i]=val%10;
	MOVLW       LCDWriteInt_str_L0+0
	ADDWF       LCDWriteInt_i_L0+0, 0 
	MOVWF       FLOC__LCDWriteInt+0 
	MOVLW       hi_addr(LCDWriteInt_str_L0+0)
	ADDWFC      LCDWriteInt_i_L0+1, 0 
	MOVWF       FLOC__LCDWriteInt+1 
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        FARG_LCDWriteInt_val+0, 0 
	MOVWF       R0 
	MOVF        FARG_LCDWriteInt_val+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_S+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVFF       FLOC__LCDWriteInt+0, FSR1
	MOVFF       FLOC__LCDWriteInt+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;lcd.c,220 :: 		val=val/10;
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        FARG_LCDWriteInt_val+0, 0 
	MOVWF       R0 
	MOVF        FARG_LCDWriteInt_val+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_S+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_LCDWriteInt_val+0 
	MOVF        R1, 0 
	MOVWF       FARG_LCDWriteInt_val+1 
;lcd.c,221 :: 		i--;
	MOVLW       1
	SUBWF       LCDWriteInt_i_L0+0, 1 
	MOVLW       0
	SUBWFB      LCDWriteInt_i_L0+1, 1 
;lcd.c,222 :: 		}
	GOTO        L_LCDWriteInt17
L_LCDWriteInt18:
;lcd.c,223 :: 		if(field_length==-1)
	MOVLW       255
	XORWF       FARG_LCDWriteInt_field_length+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__LCDWriteInt34
	MOVLW       255
	XORWF       FARG_LCDWriteInt_field_length+0, 0 
L__LCDWriteInt34:
	BTFSS       STATUS+0, 2 
	GOTO        L_LCDWriteInt19
;lcd.c,224 :: 		while(str[j]==0) j++;
L_LCDWriteInt20:
	MOVLW       LCDWriteInt_str_L0+0
	ADDWF       LCDWriteInt_j_L0+0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(LCDWriteInt_str_L0+0)
	ADDWFC      LCDWriteInt_j_L0+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_LCDWriteInt21
	INFSNZ      LCDWriteInt_j_L0+0, 1 
	INCF        LCDWriteInt_j_L0+1, 1 
	GOTO        L_LCDWriteInt20
L_LCDWriteInt21:
	GOTO        L_LCDWriteInt22
L_LCDWriteInt19:
;lcd.c,226 :: 		j=5-field_length;
	MOVF        FARG_LCDWriteInt_field_length+0, 0 
	SUBLW       5
	MOVWF       LCDWriteInt_j_L0+0 
	MOVF        FARG_LCDWriteInt_field_length+1, 0 
	MOVWF       LCDWriteInt_j_L0+1 
	MOVLW       0
	SUBFWB      LCDWriteInt_j_L0+1, 1 
L_LCDWriteInt22:
;lcd.c,228 :: 		if(val<0) LCDData('-');
	MOVLW       128
	XORWF       FARG_LCDWriteInt_val+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__LCDWriteInt35
	MOVLW       0
	SUBWF       FARG_LCDWriteInt_val+0, 0 
L__LCDWriteInt35:
	BTFSC       STATUS+0, 0 
	GOTO        L_LCDWriteInt23
	MOVLW       45
	MOVWF       FARG_LCDByte_c+0 
	MOVLW       1
	MOVWF       FARG_LCDByte_isdata+0 
	CALL        _LCDByte+0, 0
L_LCDWriteInt23:
;lcd.c,229 :: 		for(i=j;i<5;i++)
	MOVF        LCDWriteInt_j_L0+0, 0 
	MOVWF       LCDWriteInt_i_L0+0 
	MOVF        LCDWriteInt_j_L0+1, 0 
	MOVWF       LCDWriteInt_i_L0+1 
L_LCDWriteInt24:
	MOVLW       128
	XORWF       LCDWriteInt_i_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__LCDWriteInt36
	MOVLW       5
	SUBWF       LCDWriteInt_i_L0+0, 0 
L__LCDWriteInt36:
	BTFSC       STATUS+0, 0 
	GOTO        L_LCDWriteInt25
;lcd.c,231 :: 		LCDData(48+str[i]);
	MOVLW       LCDWriteInt_str_L0+0
	ADDWF       LCDWriteInt_i_L0+0, 0 
	MOVWF       FSR2 
	MOVLW       hi_addr(LCDWriteInt_str_L0+0)
	ADDWFC      LCDWriteInt_i_L0+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	ADDLW       48
	MOVWF       FARG_LCDByte_c+0 
	MOVLW       1
	MOVWF       FARG_LCDByte_isdata+0 
	CALL        _LCDByte+0, 0
;lcd.c,229 :: 		for(i=j;i<5;i++)
	INFSNZ      LCDWriteInt_i_L0+0, 1 
	INCF        LCDWriteInt_i_L0+1, 1 
;lcd.c,232 :: 		}
	GOTO        L_LCDWriteInt24
L_LCDWriteInt25:
;lcd.c,233 :: 		}
L_end_LCDWriteInt:
	RETURN      0
; end of _LCDWriteInt

_LCDGotoXY:

;lcd.c,234 :: 		void LCDGotoXY(uint8_t x,uint8_t y)
;lcd.c,236 :: 		if(x<40)
	MOVLW       40
	SUBWF       FARG_LCDGotoXY_x+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_LCDGotoXY27
;lcd.c,238 :: 		if(y) x|=0b01000000;
	MOVF        FARG_LCDGotoXY_y+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_LCDGotoXY28
	BSF         FARG_LCDGotoXY_x+0, 6 
L_LCDGotoXY28:
;lcd.c,239 :: 		x|=0b10000000;
	MOVLW       128
	IORWF       FARG_LCDGotoXY_x+0, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	MOVWF       FARG_LCDGotoXY_x+0 
;lcd.c,240 :: 		LCDCmd(x);
	MOVF        R0, 0 
	MOVWF       FARG_LCDByte_c+0 
	CLRF        FARG_LCDByte_isdata+0 
	CALL        _LCDByte+0, 0
;lcd.c,241 :: 		}
L_LCDGotoXY27:
;lcd.c,242 :: 		}
L_end_LCDGotoXY:
	RETURN      0
; end of _LCDGotoXY
