#line 1 "C:/Users/Afnan/Downloads/PIC18_LCDlib (1)/lcd_test/MikroC/lcd.c"
#line 1 "c:/users/afnan/downloads/pic18_lcdlib (1)/lcd_test/mikroc/lcd.h"
#line 1 "c:/users/afnan/downloads/pic18_lcdlib (1)/lcd_test/mikroc/myutils.h"
#line 6 "c:/users/afnan/downloads/pic18_lcdlib (1)/lcd_test/mikroc/lcd.h"
typedef unsigned char uint8_t;
#line 37 "c:/users/afnan/downloads/pic18_lcdlib (1)/lcd_test/mikroc/lcd.h"
void LCDInit(uint8_t style);
void LCDWriteString(const char *msg);
void LCDWriteInt(int val,unsigned int field_length);
void LCDGotoXY(uint8_t x,uint8_t y);


void LCDByte(uint8_t,uint8_t);



void LCDBusyLoop();
#line 26 "C:/Users/Afnan/Downloads/PIC18_LCDlib (1)/lcd_test/MikroC/lcd.c"
void LCDByte(uint8_t c,uint8_t isdata)
{







uint8_t hn,ln;
uint8_t temp;

hn=c>>4;
ln=(c & 0x0F);

if(isdata==0)
  ( LATB &=(~(1<< 5 ))) ;
else
  ( LATB |=(1<< 5 )) ;

Delay_us(50);

 ( LATB |=(1<< 4 )) ;



temp=( LATB  & 0XF0)|(hn);
 LATB =temp;

Delay_us(1);



 ( LATB &=(~(1<< 4 ))) ;

Delay_us(1);


 ( LATB |=(1<< 4 )) ;

temp=( LATB  & 0XF0)|(ln);

 LATB =temp;

Delay_us(1);



 ( LATB &=(~(1<< 4 ))) ;

Delay_us(1);

LCDBusyLoop();
}

void LCDBusyLoop()
{


 uint8_t busy,status=0x00,temp;


  TRISB |=0x0F;


  ( LATB |=(1<< 6 )) ;
  ( LATB &=(~(1<< 5 ))) ;



 Delay_us(50);


 do
 {

  ( LATB |=(1<< 4 )) ;


 Delay_us(50);

 status= PORTB ;
 status=status<<4;

 Delay_us(50);


  ( LATB &=(~(1<< 4 ))) ;
 Delay_us(1);

  ( LATB |=(1<< 4 )) ;
 Delay_us(50);

 temp= PORTB ;
 temp&=0x0F;

 status=status|temp;

 busy=status & 0b10000000;

 Delay_us(50);
  ( LATB &=(~(1<< 4 ))) ;
 Delay_us(1);
 }while(busy);

  ( LATB &=(~(1<< 6 ))) ;

  TRISB &=0xF0;

}

void LCDInit(uint8_t style)
{
#line 152 "C:/Users/Afnan/Downloads/PIC18_LCDlib (1)/lcd_test/MikroC/lcd.c"
 Delay_ms(60);


  TRISB &=(0xF0);
  TRISB &=(~(1<< 4 ));
  TRISB &=(~(1<< 5 ));
  TRISB &=(~(1<< 6 ));

  LATB &=0XF0;
  ( LATB &=(~(1<< 4 ))) ;
  ( LATB &=(~(1<< 6 ))) ;
  ( LATB &=(~(1<< 5 ))) ;



 Delay_us(100);

  ( LATB |=(1<< 4 )) ;
  LATB |=(0b00000010);
 Delay_us(10);
  ( LATB &=(~(1<< 4 ))) ;
 Delay_us(10);


 LCDBusyLoop();



  (LCDByte(0b00001100|style,0)) ;
  (LCDByte(0b00101000,0)) ;
}
void LCDWriteString(const char *msg)
{
#line 195 "C:/Users/Afnan/Downloads/PIC18_LCDlib (1)/lcd_test/MikroC/lcd.c"
 while(*msg!='\0')
 {
  (LCDByte(*msg,1)) ;
 msg++;
 }
}

void LCDWriteInt(int val,unsigned int field_length)
{
#line 215 "C:/Users/Afnan/Downloads/PIC18_LCDlib (1)/lcd_test/MikroC/lcd.c"
 char str[5]={0,0,0,0,0};
 int i=4,j=0;
 while(val)
 {
 str[i]=val%10;
 val=val/10;
 i--;
 }
 if(field_length==-1)
 while(str[j]==0) j++;
 else
 j=5-field_length;

 if(val<0)  (LCDByte('-',1)) ;
 for(i=j;i<5;i++)
 {
  (LCDByte(48+str[i],1)) ;
 }
}
void LCDGotoXY(uint8_t x,uint8_t y)
{
 if(x<40)
 {
 if(y) x|=0b01000000;
 x|=0b10000000;
  (LCDByte(x,0)) ;
 }
}
