
#include "lcd.h"
     char i;

//Simple Delay Routine
void Wait(unsigned int delay)
{
        for(;delay;delay--)
                Delay_us(100);
}

void main()
{
        //Let the Module start up
        Wait(500);
        PORTD = 0x00;
        TRISD = 0x00;

        //Initialize the LCD Module
        LCDInit(LS_BLINK);

        //Clear the Module
        LCDClear();
        
        //Write a string at current cursor pos
        LCDWriteString("Yeh works f9!!");

        Wait(20000);

        //Now Clear the display
        LCDClear();

        LCDWriteString("God Bless all !!");

        //Goto POS (X=0,Y=1 i.e. Line 2)
        //And Write a string
        LCDWriteStringXY(0,1,"<**************>");

        Wait(20000);

        //Write Some Numbers
        for(i=0;i<100;i++)
        {
                        LCDClear();
                        LCDWriteInt(i,3);
                        Wait(3000);
        }
        
        LCDClear();
        LCDWriteString("    The  End    ");

        //Loop Forever
        while(1)
        {
            PORTD = ~PORTD;
        }

        
}